## mingw-w64-abinit-10.0.9-2.src.tar.zst

=== CMakeLists.txt ===
# using 3.18 to have nice lapack imported target
cmake_minimum_required(VERSION 3.18)

#
# User resources to help writing CMake for fortran projects:
# - book: CMake CookBook + https://github.com/dev-cafe/cmake-cookbook
# - https://cliutils.gitlab.io/modern-cmake/
# - https://enccs.github.io/cmake-workshop/cxx-fortran/
# - https://github.com/scivision/fortran2018-examples
# - MKL + pkg-config : https://www.intel.com/content/www/us/en/developer/articles/technical/intel-math-kernel-library-intel-mkl-and-pkg-config-tool.html?wapkw=mkl%20pkgconfig

#
# Allow find_package() to use <PackageName>_ROOT variables,
# either cmake variable or environment variables
# see https://cmake.org/cmake/help/latest/policy/CMP0074.html
#
if(NOT CMAKE_VERSION VERSION_LESS 3.12)
  cmake_policy(SET CMP0074 NEW)
endif()

project(abinit
  LANGUAGES C CXX Fortran
  VERSION 9.11.0
  HOMEPAGE_URL https://www.abinit.org/
  DESCRIPTION "ABINIT is an atomic-scale simulation software suite.")

#
# Export compile command to json (for editors like emacs, clion, vim, etc...).
# It allows nice code editing features provided by LSP (Language Server Protocol)
#
set(CMAKE_EXPORT_COMPILE_COMMANDS on)

#
# default local cmake macro repository (located in abinit top level sources)
#
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

#
# Enforce user to use a build directory outside of source tree
#
include(prevent_build_in_source)
prevent_build_in_source()

#
# Set default compile optimization flag
#
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(DEFAULT_BUILD_TYPE "RelWithDebInfo")
  message(STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: Debug, Release, RelWithDebInfo and MinSizeRel." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif ()

#
# Use CPM project manager for external dependencies.
# See https://github.com/TheLartians/CPM.cmake for more info
#
#include(cmake/CPM.cmake)

#
# Mixing Fortran and C
#
include(FortranCInterface)
FortranCInterface_VERIFY()
FortranCInterface_HEADER(
  fc_mangle.h
  MACRO_NAMESPACE "FC_"
  )

string(TOLOWER ${CMAKE_BUILD_TYPE} build_type)
if (build_type STREQUAL debug)
  set(DEBUG_MODE 1)
endif()

# output dir for libraries
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib
    CACHE
    PATH "Single output directory for building all libraries.")

#------------------------------------------------------------------------------#
#
# Additional compiler flags, compiler specific
#
#------------------------------------------------------------------------------#
include(compiler_setup)

#------------------------------------------------------------------------------#
#
# Top level Options
#
#------------------------------------------------------------------------------#
include(options)

#------------------------------------------------------------------------------#
#
# Check external dependencies
#
#------------------------------------------------------------------------------#

#
# BLAS / LAPACK setup
#
# this is controlled by cmake var BLA_VENDOR
# available values slightly depends on cmake version
# currently in cmake 3.18, valid values are
#
#    Goto
#    OpenBLAS
#    FLAME
#    ATLAS PhiPACK
#    CXML
#    DXML
#    SunPerf
#    SCSL
#    SGIMATH
#    IBMESSL
#    Intel10_32 (intel mkl v10 32 bit)
#    Intel10_64lp (intel mkl v10+ 64 bit, threaded code, lp64 model)
#    Intel10_64lp_seq (intel mkl v10+ 64 bit, sequential code, lp64 model)
#    Intel10_64ilp (intel mkl v10+ 64 bit, threaded code, ilp64 model)
#    Intel10_64ilp_seq (intel mkl v10+ 64 bit, sequential code, ilp64 model)
#    Intel10_64_dyn (intel mkl v10+ 64 bit, single dynamic library)
#    Intel (obsolete versions of mkl 32 and 64 bit)
#    ACML
#    ACML_MP
#    ACML_GPU
#    Apple
#    NAS
#    Arm
#    Arm_mp
#    Arm_ilp64
#    Arm_ilp64_mp
#    Generic
#
# NOTE:
# - if variable BLA_VENDOR is not set, all vendors are considered.
# - if multiple implementation are available on your system, the first to be detected,
#   will be considered
#
# Recommended value for MKL : Intel10_32
find_package(BLAS)
find_package(LAPACK)

#
# Check for buggy BLAS interfaces
# Set the ABINIT_ENABLE_ZDOT_BUGFIX flag
#
set(ABINIT_ENABLE_ZDOT_BUGFIX AUTO CACHE STRING "Activate workaround for bugged ZDOTC and ZDOTU (default: auto)")
set_property(CACHE ABINIT_ENABLE_ZDOT_BUGFIX PROPERTY STRINGS AUTO ON OFF)
if((ABINIT_ENABLE_ZDOT_BUGFIX STREQUAL "AUTO") OR (NOT ABINIT_ENABLE_ZDOT_BUGFIX))
  try_run(BLAS_BUGGY_RUN BLAS_BUGGY_COMPILE
    ${CMAKE_BINARY_DIR}/try_run ${CMAKE_SOURCE_DIR}/cmake/try_compile/have_linalg_zdot_bug.F90
    LINK_LIBRARIES BLAS::BLAS
    RUN_OUTPUT_VARIABLE BLAS_BUGGY_OUTPUT)
  STRING(STRIP "${BLAS_BUGGY_OUTPUT}" BLAS_BUGGY_OUTPUT)
  if(BLAS_BUGGY_OUTPUT STREQUAL "OK")
    set(ABINIT_ENABLE_ZDOT_BUGFIX OFF CACHE STRING "Activate workaround for bugged ZDOTC and ZDOTU (default: auto)" FORCE)
  else()
    if(NOT ABINIT_ENABLE_ZDOT_BUGFIX)
      message(FATAL_ERROR "ABINIT_ENABLE_ZDOT_BUGFIX option is deactivated but the BLAS library has buggy interfaces!")
    endif()
    set(ABINIT_ENABLE_ZDOT_BUGFIX ON CACHE STRING "Activate workaround for bugged ZDOTC and ZDOTU (default: auto)" FORCE)
  endif()
endif()
if(ABINIT_ENABLE_ZDOT_BUGFIX)
  set(HAVE_LINALG_ZDOTC_BUG 1)
  set(HAVE_LINALG_ZDOTU_BUG 1)
endif()

#
# Select FFT flavor
# available flavors are: FFTW3, MKL_DFTI, GOEDECKER, PFFT
#
set(ABINIT_FFT_FLAVOR "FFTW3" CACHE STRING
  "Possible FFT flavors are: FFTW3, MKL_DFTI, GOEDECKER or PFFT")
set_property(CACHE ABINIT_FFT_FLAVOR PROPERTY STRINGS FFTW3 MKL_DFTI GOEDECKER PFFT)

#
# Select SCALAPACK flavor
# available flavors are: NETLIB, MKL
#
# Important notes regarding MKL:
#
# If ABINIT_SCALAPACK_FLAVOR is MKL then  scalapack/mkl
#
# User must provide env variable MKL_ROOT if SCALAPACK/MKL
# is desired.
#
# Other variables of interest that are used to initialize
# MKL_BLAS_FLAVOR_DEFAULT and MKL_SCALAPACK_FLAVOR_DEFAULT
# - MKL_XX_BIT (32bit or 64bit)
# - MKL_THREADING_TYPE (omp or seq)
#
# User can override directly MKL_BLAS_FLAVOR and MKL_SCALAPACK_FLAVOR
#
set(ABINIT_SCALAPACK_FLAVOR "NETLIB" CACHE STRING
  "Possible SCALAPACK flavors are: NETLIB or MKL")
set_property(CACHE ABINIT_SCALAPACK_FLAVOR PROPERTY STRINGS NETLIB MKL)


#####################################################################
# checking for optional external dependencies :
# - MPI (OpenMPI, IntelMPI, MPICH, etc...)
# - OpenMP
# - MKL (Intel classic or newest OneAPI/MKL ?)
# - Scalapack (MKL or Netlib)
# - Libxc
#
# For each external dependency, you can :
# - instruct cmake to search for a particular directory
#   using either env variable or cmake variable <PackageName>_ROOT
# - (recommended) set env variable PKG_CONFIG_PATH to specify a list
#   of directories containing pkgconfig files (extension .pc)
# - (preferred) whenever possible, if dependency provides a cmake script
#   to detect it, just set env variable CMAKE_PREFIX_PATH
#
# On a supercomputer, most of the time, the modules environment will
# set either PKG_CONFIG_PATH and CMAKE_PREFIX_PATH
#####################################################################

# Enable MODULE mode (via pkg-config) to find packages
# see https://cmake.org/cmake/help/latest/command/find_package.html
find_package(PkgConfig REQUIRED)

#
# MPI
#
set(MPI_DETERMINE_LIBRARY_VERSION TRUE)
find_package(MPI COMPONENTS Fortran C CXX)
if(MPI_FOUND)
  add_compile_definitions(HAVE_MPI)
endif()

# determine mpi vendor (MPI_VENDOR)
# valid values are : OpenMPI, MPICH or IntelMPI
include(get_mpi_vendor)
get_mpi_vendor()

if (NOT DEFINED MPI_VERSION AND DEFINED MPI_Fortran_VERSION)
  set(MPI_VERSION ${MPI_Fortran_VERSION})
  set(MPI_VERSION_MAJOR ${MPI_Fortran_VERSION_MAJOR})
  set(MPI_VERSION_MINOR ${MPI_Fortran_VERSION_MINOR})
endif()

if (MPI_FOUND)

  # try to detect if our MPI implementation supports MPI-IO
  set(ABINIT_ENABLE_MPI_IO AUTO CACHE STRING "Enable to have MPI I/O support (default: no)")
  set_property(CACHE ABINIT_ENABLE_MPI_IO PROPERTY STRINGS AUTO ON OFF)
  if(ABINIT_ENABLE_MPI_IO STREQUAL "AUTO" OR (ABINIT_ENABLE_MPI_IO))
    try_compile(MPI_HAS_IO
      ${CMAKE_BINARY_DIR}/try_compile ${CMAKE_SOURCE_DIR}/cmake/try_compile/have_mpi_io.F90
      LINK_LIBRARIES MPI::MPI_Fortran)
    if(MPI_HAS_IO)
      set(ABINIT_ENABLE_MPI_IO ON CACHE STRING "Enable to have MPI I/O support (default: no)" FORCE)
    else()
      if(ABINIT_ENABLE_MPI_IO)
        message(FATAL_ERROR "ABINIT_ENABLE_MPI_IO option is activated but the MPI library does not support MPI-IO!")
      endif()
      set(ABINIT_ENABLE_MPI_IO OFF CACHE STRING "Enable to have MPI I/O support (default: no)" FORCE)
    endif()
  endif()
  if(ABINIT_ENABLE_MPI_IO)
    set(HAVE_MPI_IO 1)
  endif()

  # try to detect if our MPI implementation supports MPI_INPLACE
  set(ABINIT_ENABLE_MPI_INPLACE AUTO CACHE STRING "Enable the use of MPI_IN_PLACE (default: auto)")
  set_property(CACHE ABINIT_ENABLE_MPI_INPLACE PROPERTY STRINGS AUTO ON OFF)
  if((ABINIT_ENABLE_MPI_INPLACE STREQUAL "AUTO") OR (ABINIT_ENABLE_MPI_INPLACE))
    try_compile(MPI_HAS_INPLACE
      ${CMAKE_BINARY_DIR}/try_compile ${CMAKE_SOURCE_DIR}/cmake/try_compile/have_mpi_inplace.F90
      LINK_LIBRARIES MPI::MPI_Fortran)
    if(MPI_HAS_INPLACE)
      set(ABINIT_ENABLE_MPI_INPLACE ON CACHE STRING "Enable the use of MPI_IN_PLACE (default: auto)" FORCE)
    else()
      if(ABINIT_ENABLE_MPI_INPLACE)
        message(FATAL_ERROR "ABINIT_ENABLE_MPI_INPLACE option is activated but the MPI library does not support MPI-INPLACE!")
      endif()
      set(ABINIT_ENABLE_MPI_INPLACE OFF CACHE STRING "Enable the use of MPI_IN_PLACE (default: auto)" FORCE)
    endif()
  endif()
  if(ABINIT_ENABLE_MPI_INPLACE)
    set(HAVE_MPI2_INPLACE 1)
  endif()

  # try to detect if our MPI implementation has buggy interfaces (mishandling scalars)
  set(ABINIT_ENABLE_MPI_INTERFACES_BUGFIX AUTO CACHE STRING "Enable a workaround for buggy MPI interfaces (mishandling scalars) (default: auto)")
  set_property(CACHE ABINIT_ENABLE_MPI_INTERFACES_BUGFIX PROPERTY STRINGS AUTO ON OFF)
  if((ABINIT_ENABLE_MPI_INTERFACES_BUGFIX STREQUAL "AUTO") OR (NOT ABINIT_ENABLE_MPI_INTERFACES_BUGFIX))
    try_compile(MPI_NOT_BUGGY
      ${CMAKE_BINARY_DIR}/try_compile ${CMAKE_SOURCE_DIR}/cmake/try_compile/have_mpi_buggy_interfaces.F90
      LINK_LIBRARIES MPI::MPI_Fortran)
    if(NOT MPI_NOT_BUGGY)
      set(ABINIT_ENABLE_MPI_INTERFACES_BUGFIX ON CACHE STRING "Enable a workaround for buggy MPI interfaces (mishandling scalars) (default: auto)" FORCE)
    else()
      if(NOT ABINIT_ENABLE_MPI_INTERFACES_BUGFIX)
        message(FATAL_ERROR "ABINIT_ENABLE_MPI_INTERFACES_BUGFIX option is deactivated but the MPI library has buggy interfaces!")
      endif()
      set(ABINIT_ENABLE_MPI_INTERFACES_BUGFIX OFF CACHE STRING "Enable a workaround for buggy MPI interfaces (mishandling scalars) (default: auto)" FORCE)
    endif()
  endif()
  if(ABINIT_ENABLE_MPI_INTERFACES_BUGFIX)
    set(HAVE_MPI_BUGGY_INTERFACES 1)
  endif()

  # try to detect if our MPI implementation is cuda-aware
  # 1. If using OpenMPI, then try to parse output of ompi_info
  # 2. If using MPICH, TODO
  # 3. Other MPI impl, TODO
  if (ABINIT_ENABLE_GPU_CUDA)

    if (MPI_VENDOR STREQUAL "OpenMPI")
      find_program(OMPI_INFO
        NAMES ompi_info
        HINTS ${MPI_CXX_LIBRARIES}/../bin)

      # Full command line to probe if cuda support in MPI implementation is enabled
      # ompi_info --parsable --all | grep mpi_built_with_cuda_support:value
      if (OMPI_INFO)
        execute_process(COMMAND ${OMPI_INFO}
          OUTPUT_VARIABLE _output)
        if ( (_output MATCHES "smcuda") )

=== src/CMakeLists.txt ===
add_subdirectory(41_geometry)
add_subdirectory(42_nlstrain)
add_subdirectory(42_parser)
add_subdirectory(43_ptgroups)
add_subdirectory(43_wvl_wrappers)
add_subdirectory(44_abitools)
add_subdirectory(44_abitypes_defs)
add_subdirectory(45_geomoptim)
add_subdirectory(45_xgTools)
add_subdirectory(46_ghc_omp)
if(DO_BUILD_46_MANAGE_CUDA)
  add_subdirectory(46_manage_cuda)
endif()
if(DO_BUILD_44_MANAGE_KOKKOS)
  add_subdirectory(44_manage_kokkos)
endif()
add_subdirectory(48_diago)
add_subdirectory(49_gw_toolbox_oop)
add_subdirectory(51_manage_mpi)
add_subdirectory(52_fft_mpi_noabirule)
add_subdirectory(53_ffts)
add_subdirectory(54_spacepar)
add_subdirectory(55_abiutil)
add_subdirectory(56_io_mpi)
add_subdirectory(56_mixing)
add_subdirectory(56_recipspace)
add_subdirectory(56_xc)
add_subdirectory(57_iopsp_parser)
add_subdirectory(57_iovars)
add_subdirectory(61_occeig)
add_subdirectory(62_cg_noabirule)
add_subdirectory(62_ctqmc)
add_subdirectory(62_iowfdenpot)
add_subdirectory(62_poisson)
add_subdirectory(62_wvl_wfs)
add_subdirectory(64_psp)
add_subdirectory(65_lotf_base)
add_subdirectory(65_paw)
add_subdirectory(66_nonlocal)
add_subdirectory(66_vdwxc)
add_subdirectory(66_wfs)
add_subdirectory(67_common)

if(DO_BUILD_67_PYTHON_INVOCATION_EXT)
  add_subdirectory(67_python_invocation_ext)
endif()

if(DO_BUILD_67_TRIQS_EXT)
  add_subdirectory(67_triqs_ext)
endif()

add_subdirectory(68_dmft)
add_subdirectory(68_lotf)
add_subdirectory(68_recursion)
add_subdirectory(68_rsprc)
add_subdirectory(69_wfdesc)
add_subdirectory(70_gw)
add_subdirectory(71_bse)
add_subdirectory(71_wannier)
add_subdirectory(72_response)
add_subdirectory(77_ddb)
add_subdirectory(77_suscep)
add_subdirectory(78_effpot)
add_subdirectory(78_eph)
add_subdirectory(79_seqpar_mpi)
add_subdirectory(80_rttddft)
add_subdirectory(80_tdep)
add_subdirectory(94_scfcv)
add_subdirectory(95_drive)
add_subdirectory(98_main)

=== src/41_geometry/CMakeLists.txt ===
#
# 41_geometry
#
add_library(41_geometry STATIC
  m_ab7_symmetry.F90
  m_crystal.F90
  m_ewald.F90
  m_geometry.F90
  m_gtermcutoff.F90
  m_spgdata.F90
  m_spgbuilder.F90
  m_supercell.F90
  m_symlist.F90
  m_symsg.F90
  m_symfind.F90
  )

set_target_properties(41_geometry
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(41_geometry
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(41_geometry
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(41_geometry
  PUBLIC
  abinit::28_numeric_noabirule
  abinit::32_util
  abinit::39_libpaw
  )

add_library(abinit::41_geometry ALIAS 41_geometry)

=== src/42_parser/CMakeLists.txt ===
#
# 42_parser
#
add_library(42_parser STATIC
  m_parser.F90
  )

set_target_properties(42_parser
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(42_parser
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(42_parser
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(42_parser
  PUBLIC
  abinit::16_hideleave
  abinit::32_util
  abinit::41_geometry
  )

add_library(abinit::42_parser ALIAS 42_parser)

=== src/45_xgTools/CMakeLists.txt ===
#
# 45_xgTools
#
set(45_xgTools_SRC
  m_xg.F90
  m_xg_ortho_RR.F90
  m_xgScalapack.F90
  m_xgTransposer.F90
  )

add_library(45_xgTools STATIC
  ${45_xgTools_SRC})

set_target_properties(45_xgTools
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(45_xgTools
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_SOURCE_DIR}/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(45_xgTools
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(45_xgTools
  PUBLIC
  abinit::44_abitools
  abinit::44_abitypes_defs)

if(ABINIT_ENABLE_GPU_CUDA AND ABINIT_KOKKOS_WANTED)
  target_link_libraries(45_xgTools
    PUBLIC
    abinit::44_manage_kokkos
  )
endif()

if(OpenMP_FOUND)
  target_link_libraries(45_xgTools
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

if(HAVE_OPENMP_OFFLOAD)
  target_compile_options(45_xgTools
    PRIVATE
    $<$<COMPILE_LANGUAGE:Fortran>:${OPENMP_OFFLOAD_FLAGS}>)
endif()

if (ABINIT_YAKL_WANTED)
  target_link_libraries(45_xgTools
    PUBLIC
    abinit::yakl)
  target_include_directories(45_xgTools
    PUBLIC
    ${YAKL_BINARY_DIR})
endif()

add_library(abinit::45_xgTools ALIAS 45_xgTools)

=== src/52_fft_mpi_noabirule/CMakeLists.txt ===
#
# 52_fft_mpi_noabirule
#
add_library(52_fft_mpi_noabirule STATIC
  defs_fftdata.F90
  m_fftw3.F90
  m_dfti.F90
  m_fftcore.F90
  m_fft_mesh.F90
  m_sgfft.F90
  m_sg2002.F90
  )

set_target_properties(52_fft_mpi_noabirule
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(52_fft_mpi_noabirule
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(52_fft_mpi_noabirule
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(52_fft_mpi_noabirule
  PUBLIC
  abinit::44_abitools
  abinit::51_manage_mpi)

if(OpenMP_FOUND)
  target_link_libraries(52_fft_mpi_noabirule
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

if (ABINIT_FFT_FLAVOR MATCHES "GOEDECKER")
  # no linking required
else()
  target_link_libraries(52_fft_mpi_noabirule
    PUBLIC
    abinit::fft)
endif()

add_library(abinit::52_fft_mpi_noabirule ALIAS 52_fft_mpi_noabirule)

=== src/56_io_mpi/CMakeLists.txt ===
#
# 56_io_mpi
#
add_library(56_io_mpi STATIC
  m_abi_etsf.F90
  m_exit.F90
  m_hdr.F90
  m_rwwf.F90
  )

set_target_properties(56_io_mpi
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(56_io_mpi
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(56_io_mpi
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(56_io_mpi
  PUBLIC
  abinit::43_wvl_wrappers
  abinit::44_abitypes_defs
  abinit::51_manage_mpi
  )

add_library(abinit::56_io_mpi ALIAS 56_io_mpi)

=== src/61_occeig/CMakeLists.txt ===
#
# 61_occeig
#
add_library(61_occeig STATIC
  m_occ.F90
  m_ebands.F90
  m_fstab.F90
  m_extfpmd.F90
  )

set_target_properties(61_occeig
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(61_occeig
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_SOURCE_DIR}/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(61_occeig
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(61_occeig
  PUBLIC
  abinit::44_abitypes_defs
  abinit::56_recipspace
  abinit::56_io_mpi
  )

if(OpenMP_FOUND)
  target_link_libraries(61_occeig
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

add_library(abinit::61_occeig ALIAS 61_occeig)

=== src/62_iowfdenpot/CMakeLists.txt ===
#
# 62_iowfdenpot
#
add_library(62_iowfdenpot STATIC
  m_io_screening.F90
  m_wfk.F90
  m_outqmc.F90
  m_outwant.F90
  )

set_target_properties(62_iowfdenpot
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(62_iowfdenpot
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_SOURCE_DIR}/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(62_iowfdenpot
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(62_iowfdenpot
  PUBLIC
  abinit::10_defs
  abinit::16_hideleave
  abinit::27_toolbox_oop
  abinit::44_abitypes_defs
  abinit::49_gw_toolbox_oop
  abinit::56_io_mpi
  abinit::61_occeig
  abinit::62_cg_noabirule
  )

add_library(abinit::62_iowfdenpot ALIAS 62_iowfdenpot)

=== src/62_wvl_wfs/CMakeLists.txt ===
#
# 62_wvl_wfs
#
add_library(62_wvl_wfs STATIC
  m_wvl_psi.F90
  m_wvl_rwwf.F90
 )

set_target_properties(62_wvl_wfs
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(62_wvl_wfs
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_SOURCE_DIR}/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(62_wvl_wfs
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(62_wvl_wfs
  PUBLIC
  abinit::10_defs
  abinit::16_hideleave
  abinit::43_wvl_wrappers
  abinit::44_abitypes_defs
  abinit::51_manage_mpi
  abinit::56_io_mpi
  )

add_library(abinit::62_wvl_wfs ALIAS 62_wvl_wfs)

=== src/64_psp/CMakeLists.txt ===
#
# 64_psp
#
add_library(64_psp STATIC
  m_atm2fft.F90
  m_psptk.F90
  m_psps.F90
  m_pspini.F90
  m_psp1.F90
  m_psp_hgh.F90
  m_psp5.F90
  m_psp6.F90
  m_psp8.F90
  m_psp9.F90
  m_upf2abinit.F90
  )

set_target_properties(64_psp
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(64_psp
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_SOURCE_DIR}/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(64_psp
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(64_psp
  PUBLIC
  abinit::10_defs
  abinit::16_hideleave
  abinit::53_ffts
  abinit::57_iovars
  abinit::57_iopsp_parser
  )

add_library(abinit::64_psp ALIAS 64_psp)

=== src/65_paw/CMakeLists.txt ===
#
# 65_paw
#
add_library(65_paw STATIC
  m_fourier_interpol.F90
  m_paw_atomorb.F90
  m_paw_correlations.F90
  m_paw_denpot.F90
  m_paw_dfpt.F90
  m_paw_dfptnl.F90
  m_paw_dmft.F90
  m_paw_efield.F90
  m_paw_hr.F90
  m_paw_init.F90
  m_paw_lmn.F90
  m_paw_mkaewf.F90
  m_paw_mkrho.F90
  m_paw_nhat.F90
  m_paw_nmr.F90
  m_paw_occupancies.F90
  m_paw_optics.F90
  m_paw_overlap.F90
  m_paw_pwaves_lmn.F90
  m_paw_slater.F90
  m_paw_sym.F90
  m_paw_tools.F90
  m_paw_uj.F90
  m_pawfgr.F90
  m_pawpwij.F90
  )

set_target_properties(65_paw
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules)

target_include_directories(65_paw
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_SOURCE_DIR}/src/incs
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/modules
  )

target_compile_definitions(65_paw
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(65_paw
  PUBLIC
  abinit::10_defs
  abinit::16_hideleave
  abinit::27_toolbox_oop
  abinit::43_wvl_wrappers
  abinit::44_abitypes_defs
  abinit::56_io_mpi
  abinit::56_xc
  abinit::56_recipspace
  abinit::61_occeig
  abinit::62_ctqmc
  abinit::64_psp
  )

if(OpenMP_FOUND)
  target_link_libraries(65_paw
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

add_library(abinit::65_paw ALIAS 65_paw)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=abinit
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=10.0.9
pkgrel=2
pkgdesc="Atomic-scale simulation software. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='https://www.abinit.org'
msys2_repository_url="https://github.com/abinit/abinit"
msys2_references=(
  'aur: abinit'
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-libpsml"
         "${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-netcdf-fortran"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-omp")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-msmpi"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-wannier90")
source=("https://forge.abinit.org/${_realname}-${pkgver}.tar.gz"
        "001-fix-build-on-mingw.patch"
        "002-fix-pkgconfig-file.patch"
        "003-fix-version.patch")
sha256sums=('17650580295e07895f6c3c4b1f3f0fe0e0f3fea9bab5fd8ce7035b16a62f8e5e'
            '41ee6253fffc56503ebf2a11ddc5016f67fb014717588b28eedd9381af96399d'
            '466f7f86384f02c99e9f7a948f2b38229a10962ff849cd1e8bf06b0c6ddd7481'
            '72f10de92d58e54ffc814ff03956ca1db89e92c893b9896b774a29f0abff516f')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -Np1 -i "${srcdir}"/001-fix-build-on-mingw.patch
  patch -Np1 -i "${srcdir}"/002-fix-pkgconfig-file.patch
  patch -Np1 -i "${srcdir}"/003-fix-version.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  FFLAGS="-O2" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;-DPYMOD_INSTALL_LIBDIR=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_C_STANDARD=17 \
      "${_extra_config[@]}" \
      -DBLA_VENDOR=OpenBLAS \
      -DWANNIER_ROOT=${MINGW_PREFIX} \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/COPYING
}
